#!/usr/bin/env python
# coding: utf-8

# Lehenengo, datuak entrenamendu eta testatze datuetan banatu dira.

# In[ ]:


import pandas as pd
import random

#Ausaz pelikulen %10 hartzeko
def list_samp(puniq):
    elem_kop = len(puniq)
    hamar = -int((-elem_kop*0.1)//1)
    test = random.sample(puniq, hamar)
    train = [elem for elem in puniq if elem not in test]
    return train, test


# In[ ]:


# 1 KLASEA

# Datu-basea irakurri
dataset1 = pd.read_csv('F:/GrAL/6bert/dft1_over.csv')
print('irakurrita')

# Train eta test datu-baseak sortu
train_data1 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])
test_data1 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])

# Pelikula kopuruaren arabera banatu
puniq1 = dataset1['PELI'].unique().tolist()
train, test = list_samp(puniq1)

for p_train in train:
    d1_train = dataset1[dataset1['PELI']==p_train]
    train_data1 = pd.concat([train_data1, d1_train], ignore_index=True)
    
for p_test in test:
    d1_test = dataset1[dataset1['PELI']==p_test]
    test_data1 = pd.concat([test_data1, d1_test], ignore_index=True)
    
print(len(train_data1), len(test_data1), len(train), len(test))    


# In[ ]:


# 2 KLASEA

# Datu-basea irakurri
dataset2 = pd.read_csv('F:/GrAL/6bert/dft2_over.csv')
print('irakurrita')

# Train eta test datu-baseak sortu
train_data2 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])
test_data2 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])

# Pelikula kopuruaren arabera banatu
puniq2 = dataset2['PELI'].unique().tolist()
train, test = list_samp(puniq2)

for p_train in train:
    d2_train = dataset2[dataset2['PELI']==p_train]
    train_data2 = pd.concat([train_data2, d2_train], ignore_index=True)
    
for p_test in test:
    d2_test = dataset2[dataset2['PELI']==p_test]
    test_data2 = pd.concat([test_data2, d2_test], ignore_index=True)
    
print(len(train_data2), len(test_data2), len(train), len(test))        


# In[ ]:


# 3 KLASEA

# Datu-basea irakurri
dataset3 = pd.read_csv('F:/GrAL/6bert/dft3_over.csv')
print('irakurrita')

# Train eta test datu-baseak sortu
train_data3 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])
test_data3 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])

# Pelikula kopuruaren arabera banatu
puniq3 = dataset3['PELI'].unique().tolist()
train, test = list_samp(puniq3)

for p_train in train:
    d3_train = dataset3[dataset3['PELI']==p_train]
    train_data3 = pd.concat([train_data3, d3_train], ignore_index=True)
    
for p_test in test:
    d3_test = dataset3[dataset3['PELI']==p_test]
    test_data3 = pd.concat([test_data3, d3_test], ignore_index=True)
    
print(len(train_data3), len(test_data3), len(train), len(test))


# In[ ]:


# 4 KLASEA

# Datu-basea irakurri
dataset4 = pd.read_csv('F:/GrAL/6bert/dft4_over.csv')
print('irakurrita')

# Train eta test datu-baseak sortu
train_data4 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])
test_data4 = pd.DataFrame(columns=['TWEETS', 'CLASE', 'PELI'])

# Pelikula kopuruaren arabera banatu
puniq4 = dataset4['PELI'].unique().tolist()
train, test = list_samp(puniq4)

for p_train in train:
    d4_train = dataset4[dataset4['PELI']==p_train]
    train_data4 = pd.concat([train_data4, d4_train], ignore_index=True)
    
for p_test in test:
    d4_test = dataset4[dataset4['PELI']==p_test]
    test_data4 = pd.concat([test_data4, d4_test], ignore_index=True)
    
print(len(train_data4), len(test_data4), len(train), len(test))        


# In[ ]:


# Datuak elkartu
train_data = pd.concat([train_data1, train_data2, train_data3, train_data4])
test_data = pd.concat([test_data1, test_data2, test_data3, test_data4])

# Bi datu-baseak csv fitxategietan gorde
train_data.to_csv('F:/GrAL/NUEVO/dftrain_final.csv', index=False)
test_data.to_csv('F:/GrAL/NUEVO/dftest_final.csv', index=False)


# A neurona-sarerako erabilitako kode berdina erabili da, baina kasu honetara moldatuz.
# 

# In[ ]:


import pandas as pd
import numpy as np
from sklearn.model_selection import train_test_split

dftrain = pd.read_csv('F:/GrAL/NUEVO/dftrain_final.csv')
dftest = pd.read_csv('F:/GrAL/NUEVO/dftest_final.csv')


# In[ ]:


# Entrenamendu datuak egokitu

import numpy as np
import pandas as pd


X_str = dftrain['TWEETS']
y_mal = dftrain['CLASE']

X = []
y = []

for emb_str in X_str:
    embedding = []
    emb_str = emb_str[1:-1]
    emb = emb_str.split(', ')
    for num in emb:
        embedding.append(float(num))
    X.append(embedding)

for clase in y_mal:
    y.append(int(clase-1))

X_train = np.asarray(X)
y_train = np.asarray(y)
print(len(y_train))


# In[ ]:


# Testatze datuak egokitu

import numpy as np
import pandas as pd


X_str = dftest['TWEETS']
y_mal = dftest['CLASE']

X = []
y = []

for emb_str in X_str:
    embedding = []
    emb_str = emb_str[1:-1]
    emb = emb_str.split(', ')
    for num in emb:
        embedding.append(float(num))
    X.append(embedding)

for clase in y_mal:
    y.append(int(clase-1))

X_test = np.asarray(X)
y_test = np.asarray(y)

print(len(X))
print(len(y_test))


# In[ ]:


import tensorflow as tf
from tensorflow import keras
from tensorflow.keras import layers
from tensorflow.keras.callbacks import EarlyStopping

# Ausazko hazia zehaztu eredua exekutatzen den bakoitzean berdin mantentzeko
np.random.seed(13)
tf.random.set_seed(13)

# Entrenamenduan eredua hobetzeaz uzten badu, entrenamendua geldituko da
early_stopping = EarlyStopping(monitor='val_loss', patience=2)

# Neurona-sarearen egitura
model = tf.keras.Sequential([
    tf.keras.layers.Dense(24, activation='relu', input_shape=(768,)),
    tf.keras.layers.Dense(12, activation='relu'),
    tf.keras.layers.Dense(4, activation='softmax')
    ])
    
# Optimizazio algoritmoa zehaztu
adam = tf.keras.optimizers.Adam(
    learning_rate=0.00096,
    beta_1=0.899,
    beta_2=0.999,
    epsilon=1e-07
    )

# Neurona-sarea konpilatu
model.compile(loss='sparse_categorical_crossentropy', optimizer=adam, metrics=['accuracy'], callbacks=[early_stopping])

# Neurona-sarea entrenatu
entreno = model.fit(X_train, y_train, epochs=45, batch_size=500, validation_data=(X_test, y_test))


# Kalifikazioa lortzeko kodea A neurona-sarearen berdina da:

# In[ ]:


# Testatze-datuekin ebaluatu
loss, accuracy = model.evaluate(X_test, y_test, verbose=False)
y_ebal = np.argmax(model.predict(X_test), axis=-1)

# Konfusio matrizea kalkulatu
km = confusion_matrix(y_test, y_ebal)
print(km)

# F1 score kalkulatu
f1 = f1_score(y_test, y_ebal, average='weighted')
print("F1 score:", f1)


# Orain, *mayority voting*-a inplementatuko da.

# In[ ]:


# Emaitzak gordetzeko datu-basea sortu
dff = pd.DataFrame(columns=['PRED', 'TRUE', 'PELI'])
dff.to_csv('F:/GrAL/NUEVO/results.csv')

# Erabiliko diren datu baseak irakurri
df = pd.read_csv('F:/GrAL/NUEVO/dftest_final.csv')
dataframe = pd.read_csv('F:/GrAL/NUEVO/results.csv')


# In[ ]:


from collections import Counter
import pandas as pd
import numpy as np
import os

# Jada erabili diren pelikulen zerrenda lortu (kontrol moduan)
pelis = os.listdir('F:/GrAL/NUEVO/check')

# Erabili behar diren pelikulen zerrenda
puniq = df['PELI'].unique()

# Zenbat pelikula geratzen diren jakiteko kontagailua
i=0

# Pelikulak iteratu
for p in puniq:
    i+=1
    
    # Jada erabili den pelikula bat den kontrolatzeko
    if str(p) not in pelis:
        
        # Zebat pelikula geratzen diren ikusteko
        print(str(i)+'/'+str(len(puniq))+' - '+str(float(i/len(puniq)))+'%')
        
        #Pelikularen datuak hartu
        dfp = df[df['PELI']==p]
        embeddings = dfp['TWEETS']
        clase = dfp['CLASE'].iloc[0]
        
        # Mayority voting-a egiteko zerrenda sortu
        mayority_voting = []
        
        # Embeddinga str matrize batetik int matrize batera pasa
        for emb_str in embeddings:
            embedding = []
            emb_str = emb_str[1:-1]
            emb = emb_str.split(', ')
            for num in emb:
                embedding.append(float(num))
            embedding = np.array(embedding)
            
            # Embedding-aren dimentsioak zabaldu
            embedding = np.expand_dims(embedding, axis=0)
            
            # Tweet batean neurona-sarea aplikatu
            pred = model.predict(embedding)
            
            # Sareak itzuli duen lau zenbakietatik handiena den zenbakiaren posizioa lortu (posizioa = klasea)
            sol = np.argmax(pred)
            
            # Hartutako zenbakia zerrenda batean gorde
            mayority_voting.append(sol)
            
        # Zerrendatik gehien errepikatzen den zenbakia aukeratu    
        mayor = Counter(mayority_voting).most_common(1)[0][0]
        print(mayor)
        
        # Emaitzak existitzen den datu-base batean gorde 
        data = pd.DataFrame({'PRED':mayor, 'TRUE':int(clase)-1, 'PELI':str(p)}, index=[0])
        df_berria = pd.concat([dataframe, data], ignore_index=True)
        df_berria.to_csv('F:/GrAL/NUEVO/results.csv')
        dataframe = df_berria
        
        # Erabili den pelikula check karpetan gorde kontrol moduan
        os.mkdir('F:/GrAL/NUEVO/check/'+str(p))


# In[ ]:


# Egindako predikzioak eta benetako balioak irakurri eta zerrendetan bihurtu
dataframe = pd.read_csv('F:/GrAL/NUEVO/results.csv')
y_true = dataframe['TRUE'].tolist()
y_pred = dataframe['PRED'].tolist()

# Konfusio matrizea eta F1 kalkulatu
konfusio = confusion_matrix(y_true, y_pred)
f1 = f1_score(y_true, y_pred, average='weighted')

# Imprimir la matriz de confusión y la medida F1
print("Konfusio Matrizea:")
print(konfusio)
print("F1 Score:", f1)

