#!/usr/bin/env python
# coding: utf-8

# In[ ]:


# RoBERTa erabiltzeko transformer liburutegia instalatu
get_ipython().system('pip install transformers')

# Beharrezko liburutegiak inportatu
import torch
import pandas as pd
import csv
import os
import numpy as np
from transformers import RobertaTokenizer, RobertaModel

#RoBERTaren tokenizer-a lortu eta eredua prestatu
tokenizer = RobertaTokenizer.from_pretrained('roberta-base')
model = RobertaModel.from_pretrained("roberta-base",
                                     output_hidden_states = True                   )


# Berriz ere, denbora asko hartzen duen programa bat denez, une ezberdinetan exektutatu ahal izateko eta programa gelditutako puntu beretik jaraitu ahal izateko, *bert\_checkpoint* karpetaren barruan *t1, t2, t3* eta *t4* karpetak sortu dira. Karpeta horietan jada prozesatu diren pelikula bakoitzeko testu fitxategi bat gordeko da eta horietako bakoitzean pelikularen embedding-a idatzita egongo da. Exekuzioa gelditzen bada, berriz exekutatzean karpeta horretan dauden pelikulak berriz prozesatzea saihestuko da, eta arazoren bat gertatuz gero, jada prozesatuta dauden pelikulen embedding-ak gordeta egongo dira.
# 

# In[ ]:


# Kodearen kokalekua                                     
path1 = os.getcwd()

# Jada prozesatu diren pelikulen fitxategiak gordeko diren kokalekua
path2 = "F:/GrAL/4bert/bert_checkpoint/"

# Fitxategien izenen zerrenda sortu, bat klase bakoitzeko
files1 = os.listdir(path1+"tweets1_GARBI")
files2 = os.listdir(path1+"tweets2_GARBI")
files3 = os.listdir(path1+"tweets3_GARBI")
files4 = os.listdir(path1+"tweets4_GARBI")

# Jada prozesatutako pelikulen zerrendak, bat klase bakoitzeko
check1 = os.listdir(path2+"t1")
check2 = os.listdir(path2+"t2")
check3 = os.listdir(path2+"t3")
check4 = os.listdir(path2+"t4")

# Datu-basea irakurri
df = pd.read_csv('C:/Users/User/Desktop/tfg/DATUAK/ESTREINALDIAK.csv') 

# Tituluen zerrenda
titles = df['TITULO']

# Tituluak iteratu
for i, row in df.iterrows():

    # Parametro honi esker jakin daiteke aztertzen ari den pelikula jada prozesatua dagoen edo ez
    check = 0

    # Ikusi pelikula jada prozesatu den. Prozesatu bada check=0 mantenduko da, eta oraindik prozesatu ez bada, check=1 izango da.
    if df['CLASE'][i]==1 and titles[i]+'.txt' not in check1:
        try:
            with open(path1+'tweets1_GARBI\\'+titles[i]+'.txt', 'r', encoding='utf-8') as file:
                lines = file.readlines()
                check = 1
        except FileNotFoundError:
            try:
                with open(path1+'tweets1_GARBI\\'+titles[i]+'noterm.txt', 'r', encoding='utf-8') as file:
                    lines = getRandomLines(file)
                    check = 1
            except FileNotFoundError:
                continue
            
    elif df['CLASE'][i]==2 and titles[i]+'.txt' not in check2:
        try:
            with open(path1+'tweets2_GARBI\\'+titles[i]+'.txt', 'r', encoding='utf-8') as file:
                lines = getRandomLines(file)
                check = 1
        except FileNotFoundError:
            try:
                with open(path1+'tweets2_GARBI\\'+titles[i]+'noterm.txt', 'r', encoding='utf-8') as file:
                    lines = getRandomLines(file)
                    check = 1
            except FileNotFoundError:
                continue
            
    elif df['CLASE'][i]==3 and titles[i]+'.txt' not in check3:
        try:
            with open(path1+'tweets3_GARBI\\'+titles[i]+'.txt', 'r', encoding='utf-8') as file:
                lines = getRandomLines(file)
                check = 1
        except FileNotFoundError:
            try:
                with open(path1+'tweets3_GARBI\\'+titles[i]+'noterm.txt', 'r', encoding='utf-8') as file:
                    lines = getRandomLines(file)
                    check = 1
            except FileNotFoundError:
                continue
            
    elif df['CLASE'][i]==4 and titles[i]+'.txt' not in check4:
        try:
            with open(path1+'tweets4_GARBI\\'+titles[i]+'.txt', 'r', encoding='utf-8') as file:
                lines = getRandomLines(file)
                check = 1
        except FileNotFoundError:
            try:
                with open(path1+'tweets4_GARBI\\'+titles[i]+'noterm.txt', 'r', encoding='utf-8') as file:
                    lines = getRandomLines(file)
                    check = 1
            except FileNotFoundError:
                continue
                
    # Pelikula prozesatu baldin ez bada (check=1) hurrengo kode-lerroak exekutatuko dira 
    if check == 1:
    
        # Embedding-ak iteratiboki batzen joateko zerrenda sortu (ondoren batezbestekoa egiteko erabiliko da)
        suma = [float(0)]*768

        # Prozesatu diren datuen ehunekoa ikusteko
        print(i,titles[i]+' '+str('%.1f' %(100*i/len(titles)))+'%')

        # Tweetak iteratu
        for line in lines:

            # Tweet-aren amaierako '\n' ezabatu
            line=line[:-2] 

            # Tweet-aren token-ak lortu
            inputs = tokenizer(line, max_length=513, return_tensors="pt")
            tokens_tensor = inputs["input_ids"]
            segments_tensors = inputs["attention_mask"]
            with torch.no_grad():
                outputs = model(tokens_tensor, segments_tensors)
                hidden_states = outputs[2]

            # Embedding-a lortu
            token_embeddings = torch.stack(hidden_states, dim=0)
            token_embeddings = torch.squeeze(token_embeddings, dim=1)
            token_embeddings = token_embeddings.permute(1,0,2)
            token_embeddings.size()
            token_vecs = hidden_states[-2][0]
            sentence_embedding = torch.mean(token_vecs, dim=0)

            # Jada prozesatu diren tweet-en embedding-ekin batu
            suma = np.add(suma, sentence_embedding)
            
        # Pelikularen embedding guztien batezbestekoa egin eta zerrenda arrun batean bihurtu
        embedding = (suma/len(lines)).tolist() 

        # Datu-basean gorde
        df.at[i,'EMBEDDING'] = embedding
        df.to_csv('F:/GrAL/4bert/Embedding.csv')

        # Prozesatu den pelikularen testu fitxategia sortu eta embedding-a idatzi
        if df['CLASE'][i]==1:
            with open('F:/GrAL/4bert/bert_checkpoint/t1/'+titles[i]+'.txt','w',encoding='utf-8') as txt_file:
                txt_file.write(str(embedding))
        if df['CLASE'][i]==2:
            with open('F:/GrAL/4bert/bert_checkpoint/t2/'+titles[i]+'.txt','w',encoding='utf-8') as txt_file:
                txt_file.write(str(embedding))
        if df['CLASE'][i]==3:
            with open('F:/GrAL/4bert/bert_checkpoint/t3/'+titles[i]+'.txt','w',encoding='utf-8') as txt_file:
                txt_file.write(str(embedding))
        if df['CLASE'][i]==4:
            with open('F:/GrAL/4bert/bert_checkpoint/t4/'+titles[i]+'.txt','w',encoding='utf-8') as txt_file:
                txt_file.write(str(embedding))


# 
# Orain soilik embedding-a eta embedding horri dagokion klasea besterik ez da behar, hortaz, bi aldagai hauek dituen datu-base berri bat sortu da.
# 

# In[ ]:


import pandas as pd
df = pd.read_csv('C:/Users/User/Desktop/tfg/DATUAK/ESTREINALDIAK.csv') 
gordetzeko_zutabeak = ['EMBEDDING', 'CLASE']
df = df.drop(columns=df.columns.difference(gordetzeko_zutabeak))
df.to_csv('F:/GrAL/4bert/Embedding.csv')

