#!/usr/bin/env python
# coding: utf-8

# In[ ]:


Corpusaren analisia egiteko, hainbat zerrenda sortu dira beharrezkoa den informazioa bertan gordetzeko.


# In[ ]:


# Klaseen zerrenda
klase = [1, 2, 3, 4]

# Guztira dauden pelikulak
pk1 = []

# Terminorik ez dituzten tweet-ak dituzten pelikula kopurua
pk2 = []

# Tweet-ik ez dituzten pelikula kopurua
pk3 = []

# Tweet kopurua
tkop = []


# Behin zerrendak sortu direla, analisirako informazioa lortzeko hurrengo kodea programatu da.

# In[ ]:


import os
import math 

path = os.getcwd()

# Klase bakoitzetik iteratu
for i in range(1,5):

    # Analisirako informazioa gordetzeko aldagai eta zerrendak
    num = 0
    c=0
    tk = []

    # i klasearen pelikulen zerrenda sortu
    archivos = os.listdir(path+"\\tweets"+str(i)+"_GARBI")

    # Zerrendatik iteratu
    for j in range(len(archivos)):

        # Pelikula bakoitzaren fitxategia ireki
        archivo = open(path+"\\"+archivos[j],'r', encoding='utf-8')

        # Fitxategiaren lerro bakoitzaren zerrenda sortu
        tweets = archivo.readlines()

        # Pelikula bakoitzeko tweet kopurua zenbatu eta zerrenda batean gorde
        if len(tweets) != 0:
            tk.append(len(tweets))
        archivo.close()
    
        # Terminorik gabeko tweet-ak zenbatu
        if archivos[j][-10:-4]=="noterm":
            c+=1    

    # Aurretik gordetako ezabatuen karpetatik tweet-ik ez dituzten pelikulak zenbatu
    empty = open(path+"\\Ezabatutakoak\\tweets"+str(i)+".txt", 'r', encoding = 'utf8').readlines()
    num_empty = len(empty)
       
    # Guztirazko pelikula kopurua
    pelis = os.listdir(path+"\\tweets"+str(i)+"_EDUKIA")
    num_pelis = len(pelis)

    # Klase bakoitzaren informazioa zerrendetan gorde
    pk1.append(num_pelis)
    pk2.append(c)
    pk3.append(num_empty)
    tkop.append(tk)

# Azkenik, datu-base bat sortu da
data = {"Klasea": klase,
        "Pelikula Kop1": pk1,
        "Pelikula Kop2": pk2,
        "Pelikula Kop3": pk3,
        "tkop":tkop}


# Behin informazio guztia izanik, barra-grafikoa egin da.

# In[ ]:


import matplotlib.pyplot as plt
from matplotlib import style
import matplotlib.ticker as mticker

# Irudi huts berri bat sortu
fig = plt.figure()

# Sortutako irudi hutsean grafikak hartuko dituen dimentsioak zehaztu
ax = fig.add_subplot(111)

# Zutabe bakoitzaren x ardatza zehaztu
x = data["Klasea"]
x1 = [i - 0.2 for i in x]
x2 = x
x3 = [i + 0.2 for i in x]

# Zutabe bakoitza sortu
plt.bar(x1, data["Pelikula Kop1"], 0.2, label = 'Guztira')
plt.bar(x2, data["Pelikula Kop2"], 0.2, label = 'Terminorik gabe')
plt.bar(x3, data["Pelikula Kop3"], 0.2, label = 'Tweetik gabe')

# Estiloa zehaztu
style.use('ggplot')

# Irudi-testua sortu
plt.legend(facecolor='w',loc = "best")

# x ardatzean zenbaki osoak soilik agertzeko
plt.gca().xaxis.set_major_locator(mticker.MultipleLocator(1))

# Ardatzen izenak eta izenburua
plt.xlabel('Klasea')
plt.ylabel('Pelikula Kopurua')
plt.title('Klase bakoitzeko pelikula kopurua')

# Zutabe bakoitzaren gainean bere balioa ipini
for i, v in enumerate(data["Pelikula Kop1"]):
    ax.text(i+0.8, v+27, "%d" %v, color='darkslategrey', size='x-small', ha="center")
for i, v in enumerate(data["Pelikula Kop2"]):
    ax.text(i+1, v+27, "%d" %v, color='darkslategrey', size='x-small', ha="center")
for i, v in enumerate(data["Pelikula Kop3"]):
    ax.text(i+1.2, v+20, "%d" %v, color='darkslategrey', size='x-small', ha="center")

# Barra-grafikoa ikusi eta gorde
plt.show()
plt.savefig("C:/Users/User/Desktop/1Grafikoa.jpg")


# Box plot-ak egiteko, aldiz, hurrengo kodea erabili da.

# In[ ]:


import matplotlib.pyplot as plt
import matplotlib.style as style

# Estiloa zehaztu
style.use('ggplot')

# Box plot bat sortu klase bakoitzeko
for i in range(len(data['tkop'])):

    # Boz plot-a sortu
    plt.boxplot(data['tkop'][i])

    #Izenburua ipini
    plt.title('Boxplot ' + str(i+1))
    
    # Ardatzei izena ipini
    plt.xlabel('klasea')
    plt.ylabel('Tweet kopurua')

    # x ardatzeko parametroa zehaztu
    plt.xticks([1], [str(i+1)])
    
    # Ardatzaren muga definitu
    plt.ylim(-10, 4000)  

    # Irudiak ikusi
    plt.show()

